<template>
    <div class="max-h-full flex flex-col">
        <div class="text-gray-600 clearfix mb-2 flex align-middle px-2">
            <input class="flex-grow border border-gray-400 bg-white h-10 px-3 rounded-sm text-sm focus:outline-none" autocomplete="off" v-model="customerQuery" type="search" name="search" placeholder="Search">
            <custom-button css-class="ml-2" icon="sync" @click="$store.dispatch('customer/load')"></custom-button>
        </div>

        <div class="px-2 py-2 flex-grow overflow-y-auto">
            <div 
                v-for="item in filteredCustomerList"
                :key="item.id"
                class="mb-3"
            >
                <customer :name="item.name" :userFavorite="item.userFavorite" :id="item.id" :color="item.color || '#000'" :costunits="item.costunits" :filterQuery="customerQuery" @selectCostunit="selectCostUnit" />
            </div>
        </div>
    </div>
</template>

<script>
import CustomButton from '~/components/CustomButton'
import Customer from '~/components/Customer'
import { mapState } from 'vuex'

export default {
    name : 'customers',
    components: {
        CustomButton,
        Customer
    },
    props: {
        'selectCostUnit' : { type: Function }
    },
    data() {
        return {
            customerQuery: '',
        }
    },
    computed : {
        ...mapState({
            customersList: state => state.customer.list
        }),
        ...{
            filteredCustomerList() {
                if (!this.customerQuery) {
                    return this.customersList
                }

                return this.customersList.filter(customer => {
                    if (customer.costunits.some(costunit => this.$store.getters['timeline/isCostunitActive'](costunit))) {
                        return true
                    }

                    return  customer.name.toLowerCase().includes(this.customerQuery.toLowerCase()) ||
                            customer.costunits.some(costunit => costunit.name.toLowerCase().includes(this.customerQuery.toLowerCase()))
                })
            }
        }
    }
}
</script>
